import GoogleCalendar from './GoogleCalendar';
import GameSource from './GameSource';
import { GoogleCalendarEvent } from './types/index';


// crete App class
// app class will be the main class of our application
// it will be collecting macabi haifa events from GameSource class
// it will be responsible for update GameSource events in google calendar
// it will be responsible for update GameSource events in local file



class App {
  googleCalendar: GoogleCalendar;
  gameSource: any;
  googleToken: any;

  constructor() {
    this.googleCalendar = new GoogleCalendar();
    this.gameSource = new GameSource();
  }

  async init() {
    this.googleToken = this.googleCalendar.init();
  }

  getNewGamesAndUpdateCalendar() {
    const upcomingEvents: GoogleCalendarEvent[] = [];
    this.gameSource.getGames().then((games: any) => {
      const rootGames = games.data.sports_results;
      upcomingEvents.push({
        summary: rootGames.title,
        location: rootGames.game_spotlight.stadium,
        description: "Haifa vs. " + rootGames.game_spotlight.teams[this.getHaifaIndex(rootGames.game_spotlight.teams)].name,
        start: {
          dateTime: '2023-03-22T09:00:00-07:00',
          timeZone: 'Israel'
        },
        end: {
          dateTime: '2023-03-22T09:00:00-07:00',
          timeZone: 'Israel'
        },
        recurrence: []
      });
      console.log("Updaing new event: " + upcomingEvents[0].summary)
      console.log(upcomingEvents[0])
      this.googleCalendar.updateNewEvent(upcomingEvents);
    });
  }

  getHaifaIndex(teams: any) {
    for (let i = 0; i < teams.length; i++) {
      if (teams[i].name === "Maccabi Haifa") {
        return i;
      }
    }
  }
}

const app = new App();
app.init();
app.getNewGamesAndUpdateCalendar();
